function langlist_init()
{
    num=split(lang,a,";");
    langnum=0;

    for(i=1;i<=num;++i)
    {
	langlist[langnum++]=a[i];
	if (a[i] ~ /_/) {
	    sub(/_.*/,"",a[i]);
	    langlist[langnum++] = a[i];
	}
    }
    langlist[langnum++]="en_US";
}

function langlist_find()
{
    for(i=0;i<langnum;++i)
    {
	l = name[langlist[i]];
	if (l) return l;
    }
}

function do_reset()
{
    weight=0;
    uri="";
    icon="notfound";
    help="notfound";
    our1=(category != "")?0:1;
    our2=1;
    for(i in name) delete name[i];
}

function do_output()
{
    if (first == 1)
    {
	first = 0;
	return;
    }

    if ( our1 && our2) print weight,uri,help,icon,langlist_find();
}

BEGIN { FS="[[:space:]]*=[[:space:]]*"; OFS="\t"; langlist_init(); do_reset(); first=1; }

/^X-Alterator-Weight[[:space:]]*=/ { weight=$2 }
/^X-Alterator-URI[[:space:]]*=/ { uri=$2 }
/^X-Alterator-Help[[:space:]]*=/ { help=$2 }

/^Icon[[:space:]]*=/ { icon=$2; }
/^Name[[:space:]]*=/ { name["en_US"]=$2; }
/^Name\[[a-zA-Z_]+\][[:space:]]*=/  { name[gensub(/Name\[([^\]]+)\]/,"\\1","",$1)]=$2; }

$0 ~ "^Categories[[:space:]]*=[[:space:]]*(.*;)?"category"(;|$)" {  our1=1; }

/^X-Alterator-UI[[:space:]]*=/ {  our2=0; }
$0 ~ "^X-Alterator-UI[[:space:]]*=[[:space:]]*(.*;)?"ui"(;|$)" {  our2=1; }

/\[Desktop Entry\]/ { do_output(); do_reset(); }

END { do_output(); }
